DROP SCHEMA IF EXISTS fiskeri;

BEGIN;
CREATE SCHEMA fiskeri;
CREATE TABLE fiskeri.kvoter_raw ( 
    Data_pr text,
    Fartøy_ID text,
    Registreringsmerke text,
    Tillatelse_kode text,
    Tillatelse text,
    Tillatelse_ID text,
    Tillatelse_fra_dato text,
    Tillatelse_til_dato text,
    Linjenummer int,
    Linjenummer_beskrivelse text,
    Kvotestørrelse float,
    Kvotestr_fra_dato text,
    Kvotestr_til_dato text
);

CREATE VIEW fiskeri.kvoter AS
SELECT
    regexp_replace(Data_pr, '(\d\d)\.(\d\d)\.(\d\d\d\d)(.*)', '\3-\2-\1\4')::date AS Data_pr,
    Fartøy_ID,
    Registreringsmerke,
    Tillatelse_kode,
    Tillatelse,
    Tillatelse_ID,
    regexp_replace(Tillatelse_fra_dato, '(\d\d)\.(\d\d)\.(\d\d\d\d)(.*)', '\3-\2-\1\4')::timestamp
        AS Tillatelse_fra_dato,
    regexp_replace(Tillatelse_til_dato, '(\d\d)\.(\d\d)\.(\d\d\d\d)(.*)', '\3-\2-\1\4')::timestamp
        AS Tillatelse_til_dato,
    Linjenummer,
    Linjenummer_beskrivelse,
    Kvotestørrelse,
    regexp_replace(Kvotestr_fra_dato, '(\d\d)\.(\d\d)\.(\d\d\d\d)(.*)', '\3-\2-\1\4')::date
        AS Kvotestr_fra_dato,
    regexp_replace(Kvotestr_til_dato, '(\d\d)\.(\d\d)\.(\d\d\d\d)(.*)', '\3-\2-\1\4')::date
        AS Kvotestr_til_dato
FROM fiskeri.kvoter_raw;
COMMIT;
